/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH375 **
**  TC2.0@PC, WinAVR_GCC_3.45@AVR     **
****************************************
*/
/* CH375 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* AVRƬCԵUļдʾ */
/* óUе/C51/CH375HFT.Cļеǰ600ַʾ,
   ҲԭļCH375HFT.C, ôóʾC51Ŀ¼CH375ͷļ,
   ҲC51Ŀ¼, ôóʾĿ¼µļ,
   󽫳ROMеһַдд½ļ"NEWFILE.TXT"
*/
/* CH375INT#Ųòѯʽ, ݸƷʽΪ"ڲ", ATmega128Ƭ, 0Ϣ,9600bps */
/* ֽΪλдUļ,дٶȽģʽ,ֽģʽдļҪļݻFILE_DATA_BUF,
   ֻܹҪ600ֽڵRAM,ڵƬӲԴޡСҶдٶҪ󲻸ߵϵͳ */

/* AVR-GCC -v -mmcu=atmega128 -O2 -xc CH375HFT.c -oCH375HFT.ELF -lCH375HFD */
/* AVR-OBJCOPY -j .text -j .data -O ihex CH375HFT.ELF CH375HFT.HEX */

#include <string.h>
#include <stdio.h>
#define		F_CPU	16000000		/* ƬƵΪ16MHz,ʱӳ */
#include <util/delay.h>
#include <avr/io.h>

/* ¶ϸ˵뿴CH375HF9.Hļ */
#define LIB_CFG_FILE_IO			1		/* ļдݵĸƷʽ,0Ϊ"ⲿӳ",1Ϊ"ڲ" */
#define LIB_CFG_INT_EN			0		/* CH375INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ƬRAM,CH375ӳ512ֽ,ʣRAMֿļд */
#define FILE_DATA_BUF_LEN		0x0200	/* ⲿRAMļݻ,ȲСһζдݳ */

#define CH375_INT_WIRE			( PINB & 0x10 )	/* PINB.4, CH375жINT#,CH375INT#,ڲѯж״̬ */

#define NO_DEFAULT_CH375_F_ENUM		1		/* δCH375FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH375_F_QUERY	1		/* δCH375FileQueryʽֹԽԼ */

#include "..\CH375HFD.H"

/* ЩAVRƬṩϵͳ,ôֱӽCH375ϵͳ,8λI/Oʽжд */
/* ȻAtmega128ṩϵͳ,ٶϵͳ,I/OģCH375Ĳڶдʱ */
/* еӲӷʽ(ʵӦõ·Բ޸3ڶдӳ) */
/*    Ƭ     CH375оƬ
       PINB.4                INT#
       PORTB.3               A0
       PORTB.2               CS#
       PORTB.1               WR#
       PORTB.0               RD#
      PORTA(8λ˿)        D7-D0       */

#ifdef F_CPU
// ʹϵͳdelay.hṩ
#define	mDelay1uS( )	_delay_us(1)
#else
void mDelay1uS( )  /* ʱ1uS,ݵƬƵ */
{
//	UINT16	i;
//	for ( i = 5; i != 0; i -- );
// ϴᱻŻǶʽ
	UINT8	count = 5;  /* ʱ1uS,3x50nS@20MHz */
	__asm__ volatile (
		"1: dec %0" "\n\t"
		"brne 1b"
		: "=r" (count)
		: "0" (count)
	);
}
#endif

void CH375_PORT_INIT( )  /* ʹͨI/Oģ鲢ڶдʱ,Խгʼ */
{
	DDRA = 0x00;  /* 8λΪ */
	PORTB = 0x07;  /* CS,WR,RDĬΪߵƽ */
	DDRB = 0x0F;  /* CS,WR,RD,A0Ϊ,INT#Ϊ */
}

void xWriteCH375Cmd( UINT8 mCmd )		/* ⲿıCH375õӳ,CH375д */
{
	mDelay1uS( ); mDelay1uS( );  /* ʱ1uS */
/*	*(volatile unsigned char *)CH375_CMD_PORT_ADDR = mCmd;  ֱͨӶдCH375ͨI/Oģ */
	PORTB |= 0x08;  /* A0=1 */
	PORTA = mCmd;  /* CH375Ĳ */
	DDRA = 0xFF;  /* D0-D7 */
	PORTB &= 0xF9;  /* Чдź, дCH375оƬ˿, A0=1; CS=0; WR=0; RD=1; */
	DDRA = 0xFF;  /* ò,ʱ,CH375Ҫдȴ100nS */
	PORTB |= 0x07;  /* ЧĿź, ɲCH375оƬ, A0=1; CS=1; WR=1; RD=1; */
	DDRA = 0x00;  /* ֹ */
	PORTB &= 0xF7;  /* A0=0; ѡ */
	mDelay1uS( ); mDelay1uS( );  /* ʱ2uS */
}

void xWriteCH375Data( UINT8 mData )		/* ⲿıCH375õӳ,CH375д */
{
/*	*(volatile unsigned char *)CH375_DAT_PORT_ADDR = mData;  ֱͨӶдCH375ͨI/Oģ */
	PORTA = mData;  /* CH375Ĳ */
	DDRA = 0xFF;  /* D0-D7 */
	PORTB &= 0xF1;  /* Чдź, дCH375оƬݶ˿, A0=0; CS=0; WR=0; RD=1; */
	DDRA = 0xFF;  /* ò,ʱ,CH375Ҫдȴ100nS */
	PORTB |= 0x07;  /* ЧĿź, ɲCH375оƬ, A0=0; CS=1; WR=1; RD=1; */
	DDRA = 0x00;  /* ֹ */
	mDelay1uS( );  /* ʱ1.2uS */
}

UINT8 xReadCH375Data( void )			/* ⲿıCH375õӳ,CH375 */
{
	UINT8	mData;
/*	mData = *(volatile unsigned char *)CH375_DAT_PORT_ADDR;  ֱͨӶдCH375ͨI/Oģ */
	mDelay1uS( );  /* ʱ1.2uS */
	DDRA = 0x00;  /*  */
	PORTB &= 0xF2;  /* Чź, CH375оƬݶ˿, A0=0; CS=0; WR=1; RD=0; */
	DDRA = 0x00;  /* ò,ʱ,CH375Ҫдȴ100nS */
	mData = PINA;  /* CH375ĲPA */
	PORTB |= 0x07;  /* ЧĿź, ɲCH375оƬ, A0=0; CS=1; WR=1; RD=1; */
	return( mData );
}

/* P0.2һLEDڼʾĽ,͵ƽLED */
#define LED_OUT_INIT( )		{ PORTB |= 0x80; DDRB |= 0x80; }	/* PORTB.7 ߵƽΪ */
#define LED_OUT_ACT( )		{ PORTB &= 0x7F; }	/* PORTB.7 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ PORTB |= 0x80; }	/* PORTB.7 ͵ƽLEDʾ */

/* ʱָʱ,ݵƬƵ,ȷ */
void	mDelaymS( UINT8 ms )
{
	UINT16	i;
	while ( ms -- ) for ( i = 1000; i != 0; i -- ) mDelay1uS( );
}

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		mDelaymS( 100 );
		LED_OUT_INACT( );
		mDelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
int		uart_putchar( char c, FILE *stream )
{
	if (c == '\n') uart_putchar( '\r', stream );
	while ( ( UCSR0A & ( 1 << UDRE ) ) == 0 );
	UDR0 = c;
	return 0;
}

FILE	uart_str = FDEV_SETUP_STREAM( uart_putchar, NULL, _FDEV_SETUP_WRITE );

void	mInitSTDIO( )
{
	UBRR0H = 0;
	UBRR0L = 103;  /* 9600bps@16MHz */
	UCSR0B = 0x18; /* BIT(RXEN) | BIT(TXEN); */
	UCSR0C = 0x06; /* BIT(UCSZ1) | BIT(UCSZ0); */
	stdout = stdin = &uart_str;
}

int		main( ) {
	UINT8	i, c;
	UINT16	TotalCount;
	UINT8	*pCodeStr;
	CH375_PORT_INIT( );
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	mDelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH375רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH375LibInit( );  /* ʼCH375CH375оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
//		while ( CH375DiskStatus != DISK_CONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴU̲ */
		while ( CH375DiskStatus < DISK_CONNECT ) {  /* ѯCH375жϲж״̬,ȴU̲ */
			if ( CH375DiskConnect( ) == ERR_SUCCESS ) break;  /* 豸򷵻سɹ,CH375DiskConnectͬʱȫֱCH375DiskStatus */
			mDelaymS( 100 );
		}
		LED_OUT_ACT( );  /* LED */
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
		for ( i = 0; i < 10; i ++ ) {  /* еUǷδ׼,Ա */
			mDelaymS( 100 );
			printf( "Ready ?\n" );
			if ( CH375DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
#if DISK_BASE_BUF_LEN
		if ( DISK_BASE_BUF_LEN < CH375vSectorSize ) {  /* ݻǷ㹻,CH375vSectorSizeU̵ʵС */
			printf( "Too large sector size\n" );
			while ( CH375DiskConnect( ) == ERR_SUCCESS ) mDelaymS( 100 );
			continue;
		}
#endif
/* ѯ */
/*		printf( "DiskSize\n" );
		i = CH375DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * (CH375vSectorSize/512) / 2048 ) );  // ʾΪMBΪλ
		// ԭ㷽 (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * CH375vSectorSize / 1000000 ) пǰ˺, ޸ĳʽ
*/

/* ȡԭļ */
		printf( "Open\n" );
		strcpy( (char *)mCmdParam.Open.mPathName, "/C51/CH375HFT.C" );  /* ļ,ļC51Ŀ¼ */
		i = CH375FileOpen( );  /* ļ */
		if ( i == ERR_MISS_DIR || i == ERR_MISS_FILE ) {  /* ûҵļ */
/* гļ */
			if ( i == ERR_MISS_DIR ) pCodeStr = (UINT8 *)"/*";  /* C51Ŀ¼гĿ¼µļ */
			else pCodeStr = (UINT8 *)"/C51/CH375*";  /* CH375HFT.Cļг\C51Ŀ¼µCH375ͷļ */
			printf( "List file %s\n", pCodeStr );
			for ( c = 0; c < 254; c ++ ) {  /* ǰ254ļ */
				strcpy( (char *)mCmdParam.Open.mPathName, (char *)pCodeStr );  /* ļ,*Ϊͨ,ļĿ¼ */
				i = strlen( (char *)mCmdParam.Open.mPathName );  /* ļ,Դļ */
				mCmdParam.Open.mPathName[ i ] = c;  /* ַȽ滻Ϊ,0255 */
				i = CH375FileOpen( );  /* ļ,ļкͨ*,Ϊļ */
				if ( i == ERR_MISS_FILE ) break;  /* Ҳƥļ,Ѿûƥļ */
				if ( i == ERR_FOUND_NAME ) {  /* ͨƥļ,ļ· */
					printf( "  match file %03d#: %s\n", (unsigned int)c, mCmdParam.Open.mPathName );  /* ʾźƥļĿ¼ */
					continue;  /* һƥļ,´ʱŻ1 */
				}
				else {  /*  */
					mStopIfError( i );
					break;
				}
			}
		}
		else {  /* ҵļ߳ */
			mStopIfError( i );
			TotalCount = 600;  /* ׼ȡܳ */
			printf( "ļжǰ%dַ:\n",TotalCount );
			while ( TotalCount ) {  /* ļȽϴ,һζ,ٵCH375ByteReadȡ,ļָԶƶ */
				if ( TotalCount > MAX_BYTE_IO ) c = MAX_BYTE_IO;  /* ʣݽ϶,ƵζдĳȲܳ sizeof( mCmdParam.ByteRead.mByteBuffer ) */
				else c = TotalCount;  /* ʣֽ */
				mCmdParam.ByteRead.mByteCount = c;  /* ʮֽ */
				i = CH375ByteRead( );  /* ֽΪλȡݿ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵ */
				mStopIfError( i );
				TotalCount -= mCmdParam.ByteRead.mByteCount;  /* ,ȥǰʵѾַ */
				for ( i=0; i!=mCmdParam.ByteRead.mByteCount; i++ ) printf( "%c", mCmdParam.ByteRead.mByteBuffer[i] );  /* ʾַ */
				if ( mCmdParam.ByteRead.mByteCount < c ) {  /* ʵʶַҪַ,˵ѾļĽβ */
					printf( "\n" );
					printf( "ļѾ\n" );
					break;
				}
			}
/*	    ϣָλÿʼд,ƶļָ
		mCmdParam.ByteLocate.mByteOffset = 608;  ļǰ608ֽڿʼд
		CH375ByteLocate( );
		mCmdParam.ByteRead.mByteCount = 5;  ȡ5ֽ
		CH375ByteRead( );   ֱӶȡļĵ608ֽڵ612ֽ,ǰ608ֽڱ

	    ϣӵԭļβ,ƶļָ
		CH375FileOpen( );
		mCmdParam.ByteLocate.mByteOffset = 0xffffffff;  Ƶļβ
		CH375ByteLocate( );
		mCmdParam.ByteWrite.mByteCount = 13;  д13ֽڵ
		CH375ByteWrite( );   ԭļĺ,¼ӵ13ֽڽԭļβ
		mCmdParam.ByteWrite.mByteCount = 2;  д2ֽڵ
		CH375ByteWrite( );   ԭļĺ
		mCmdParam.ByteWrite.mByteCount = 0;  д0ֽڵ,ʵϸò֪ͨļ
		CH375ByteWrite( );   д0ֽڵ,Զļĳ,ļ15,,ôִCH375FileCloseʱҲԶļ
*/
			printf( "Close\n" );
			i = CH375FileClose( );  /* رļ */
			mStopIfError( i );
		}

#ifdef EN_DISK_WRITE  /* ӳ֧д */
/* ļ */
		printf( "Create\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/NEWFILE.TXT" );  /* ļ,ڸĿ¼,ļ */
		i = CH375FileCreate( );  /* ½ļ,ļѾɾ½ */
		mStopIfError( i );
		printf( "Write\n" );
		pCodeStr = (UINT8 *)"Note: \xd\xaֽΪλUļд,ƬֻҪ600ֽڵRAM\xd\xa";
		while( 1 ) {  /* ֶдļ */
			for ( i=0; i<MAX_BYTE_IO; i++ ) {
				c = *pCodeStr;
				mCmdParam.ByteWrite.mByteBuffer[i] = c;
				if ( c == 0 ) break;  /* Դַ */
				pCodeStr++;
			}
			if ( i == 0 ) break;  /* Դַ,дļ */
			mCmdParam.ByteWrite.mByteCount = i;  /* дݵַ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵд */
			i = CH375ByteWrite( );  /* ļд */
			mStopIfError( i );
		}
/*		printf( "Modify\n" );
		mCmdParam.Modify.mFileAttr = 0xff;   : µļ,Ϊ0FFH޸
		mCmdParam.Modify.mFileTime = 0xffff;   : µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ
		mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2004, 5, 18 );  : µļ: 2004.05.18
		mCmdParam.Modify.mFileSize = 0xffffffff;   : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
		i = CH375FileModify( );   ޸ĵǰļϢ,޸
		mStopIfError( i );
*/
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 1;  /* Զļ,ֽΪλдļ,óرļԱԶļ */
		i = CH375FileClose( );
		mStopIfError( i );

/* ɾĳļ */
/*		printf( "Erase\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/OLD" );  ɾļ,ڸĿ¼
		i = CH375FileErase( );  ɾļر
		if ( i != ERR_SUCCESS ) printf( "Error: %02X\n", (UINT16)i );  ʾ
*/

/* ѯϢ */
/*		printf( "Disk\n" );
		i = CH375DiskQuery( );
		mStopIfError( i );
		printf( "Fat=%d, Total=%ld, Free=%ld\n", (UINT16)mCmdParam.Query.mDiskFat, mCmdParam.Query.mTotalSector, mCmdParam.Query.mFreeSector );
*/
#endif
		printf( "Take out\n" );
//		while ( CH375DiskStatus != DISK_DISCONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴṴγ */
		while ( CH375DiskStatus >= DISK_CONNECT ) {  /* ѯCH375жϲж״̬,ȴṴγ */
			if ( CH375DiskConnect( ) != ERR_SUCCESS ) break;
			mDelaymS( 100 );
		}
		LED_OUT_INACT( );  /* LED */
		mDelaymS( 200 );
/*		i = FILE_DATA_BUF[0];  ΪֽΪλдļ,δõļݻ,Ϊ˷ֹŻûһ» */
	}
}
